----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    22:23:31 09/24/2006 
-- Design Name: 
-- Module Name:    programmable timer
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity prog_timer is
    port (
      load_number    : in std_logic_vector(23 downto 0);
      clk, reset, ce : in std_logic;
      counter        : out std_logic_vector(23 downto 0);
      zero, tp       : out std_logic);
end prog_timer;



architecture Behavioral of prog_timer is
  signal counter_val : std_logic_vector(23 downto 0);
  signal tp_val : std_logic;
  
begin
  counter <= counter_val;
  tp <= tp_val;
  
process(clk, reset)
  begin
    -- asynchronous reset
    if (reset = '1') then
      counter_val <= load_number - 1;
      zero <= '0';
      tp_val <= '0';
    else
      if (clk = '1' and clk'event) then
        if (ce = '1') then
          if (counter_val = conv_std_logic_vector(0,counter_val'length)) then
            counter_val <= load_number - 1;
            zero <= '1';
            tp_val <= not(tp_val);
          else
            counter_val <= counter_val - 1;
            zero <= '0';
            tp_val <= tp_val; -- ??
          end if; -- counter = 0
        end if; -- ce = '1'
      end if; -- clk'even
    end if; -- reset
  end process;
end Behavioral;

